/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/


#include <libc.h>
#include <string.h>
#include <stdio.h>

#include <ostore/ostore.hh>
#include <ostore/coll.hh>
#include <ostore/relat.hh>
#include "OO7.h"
#include "GenParams.h"
#include "BenchParams.h"

//////////////////////////////////////////////////////////////////
//
// Query #2 - 1% selection on AtomicParts via build date (the
// most recent 1% of AtomicParts.)
//
/////////////////////////////////////////////////////////////////

extern os_database* oo7db;

extern int	debugMode;

//////////////////////////////////////////////////////////////////
//
// Routine to do Query #2
//
//////////////////////////////////////////////////////////////////


int query2()
{
    // choose a range of dates with the appropriate selectivity

    int dateRange = (Query2Percent * (MaxAtomicDate - MinAtomicDate)) / 100;
    int lowerDate = MaxAtomicDate - dateRange;

    if (debugMode) {
        printf("    Running Query2 with dateRange = %d, lowerDate = %d\n",
		    dateRange, lowerDate);
    }


    // first find the desired parts

    os_Set<AtomicPart*>& rslt =
                          (*AtomicPart::extent)[: buildDate >= lowerDate :];

    // now process the relevant parts

    int count = 0;
    foreach (AtomicPart* atom, rslt) {
        if (debugMode) {
            printf("    In Query2, partId = %d, buildDate = %d\n",
	                atom->id, atom->buildDate);
        }
        atom->DoNothing();
	count++;
    }
    return count;
}

