/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/


#include <libc.h>
#include <string.h>
#include <stdio.h>

#include <ostore/ostore.hh>
#include <ostore/coll.hh>
#include <ostore/relat.hh>
#include "OO7.h"
#include "GenParams.h"
#include "BenchParams.h"
#include "VarParams.h"

//////////////////////////////////////////////////////////////////
//
// Query #7 --- iterate through all atomic parts.  Checks scan
// speed.  Some duplication with other queries, especially in
// systems that lack indices and force the other queries to be
// done by iterating through sets.
//
//////////////////////////////////////////////////////////////////

extern os_database* oo7db;

extern int	debugMode;

//////////////////////////////////////////////////////////////////
//
// Routine to do Query #7
//
//////////////////////////////////////////////////////////////////


int query7()
{
    int count = 0;
    
//  foreach (AtomicPart* ap, *AtomicPart::extent, os_cursor::sorted_iteration) {

    AtomicPart* ap;
    os_cursor c(*AtomicPart::extent, os_cursor::sorted_iteration);
    for (ap = (AtomicPart*)c.first(); ap; ap = (AtomicPart*)c.next()) {

        if (debugMode) {
            printf("    In Query7, partId = %d:  ", ap->id);
        }

	ap->DoNothing();
        count++;
    }
//  }

    return count;
}

